<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../paper-input/paper-input.html">
<link rel="import" href="../paper-input/paper-textarea.html">
<link rel="import" href="../paper-button/paper-button.html">

<dom-module id="fotosocial-new-post">
  <template>
    <style>
      :host {
        display: block;
      }
    </style>
    <paper-input on-change="_photoChange" id="photo" type="file" label="Foto"></paper-input>
    <paper-textarea label="Descripción" value="{{description::input}}"></paper-textarea>
    <paper-button disabled="[[saveButtonDisabled]]" raised on-click="_savePost">Guardar Post</paper-button>
  </template>

  <script>
    /**
     * `fotosocial-new-post`
     * formulario para nuevo post
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class FotosocialNewPost extends Polymer.Element {
      static get is() { return 'fotosocial-new-post'; }
      static get properties() {
        return {
          photo: {
            type: String,
            value: ''
          },
          description: {
            type: String,
            value: ''
          },
          saveButtonDisabled: {
            type: Boolean,
            value: true,
            computed: '_validate(photo, description)'
          }
        };
      }

      _savePost() {
        this.dispatchEvent(new CustomEvent('save-post', {
          bubbles: true,
          composed: true,
          detail: {
            photo: this.photo,
            description: this.description
          }
        }));
      }

      _validate(photo, description) {
        return photo !== '' && description !== '' ? false : true;
      }

      _photoChange(e) {
        this.readFile(e.target.inputElement.inputElement.files[0])
            .then(resolve => this.set('photo', resolve))
            .catch(error => console.log(error));
      }

      readFile(photoReference) {
        const getFile = new FileReader();
        return new Promise((resolve, reject) => {
          getFile.readAsDataURL(photoReference);
          getFile.onload = base64 => {
            resolve(base64.target.result);
          };
          getFile.onerror = error => {
            reject(error);
          };
        });
      }
    }

    window.customElements.define(FotosocialNewPost.is, FotosocialNewPost);
  </script>
</dom-module>
